/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.jboss.jms.client;

import java.util.Properties;
import java.util.Random;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.jms.Connection;
import javax.jms.ConnectionFactory;
import javax.jms.JMSException;
import javax.jms.MessageConsumer;
import javax.jms.Queue;
import javax.jms.Session;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;

/**
 *
 * @author mnovak
 */
public class ManyJndiLookupTest {

    public static void main(String[] args) {

        DoLookUp doLookUp = null;

        for (int i = 0; i < Integer.valueOf(args[1]); i++)    {
            doLookUp = new DoLookUp();
            doLookUp.setHostname(args[0]);
            doLookUp.setThreadName(String.valueOf(i));
            doLookUp.start();
        }
    }
}

class DoLookUp extends Thread {

    private String hostname = "localhost";
    private String threadName = "";

    public void setHostname(String hostname)    {
        this.hostname = hostname;
    }

    public void run() {

        Context context = null;
        Connection c = null;
        Queue queue = null;
        Session session = null;

        try {
            
            System.out.println("remote://" + hostname + ":4447");
            final Properties env = new Properties();
            env.put(Context.INITIAL_CONTEXT_FACTORY, "org.jboss.naming.remote.client.InitialContextFactory");
            env.put(Context.PROVIDER_URL, "remote://" + hostname + ":4447");

            System.out.println("Thread: " + threadName + " Create jndi context - start");
            context = new InitialContext(env);
            System.out.println("Thread: " + threadName + " Created jndi context - success");
            System.out.println("Thread: " + threadName + " Do jndi lookup - start");
            ConnectionFactory cf = (ConnectionFactory) context.lookup("jms/RemoteConnectionFactory");
            System.out.println("Thread: " + threadName + " Do jndi lookup - success");
            System.out.println("Thread: " + threadName + " Try to create connection from connection factory");
            c = cf.createConnection();
            System.out.println("Thread: " + threadName + " Create connection - success");
            // don't overhelm it
            Random r = new Random();
            long timeout = -1;
            while ((timeout = r.nextLong()) <= 0)   {}
            Thread.sleep(timeout);
            System.out.println("Thread: " + threadName + " Create sessuib from connection");
            c = cf.createConnection();
            session = c.createSession(true, Session.SESSION_TRANSACTED);
            queue = (Queue) context.lookup("jms/queue/testQueue0");
            MessageConsumer consumer = session.createConsumer(queue);
            System.out.println("Thread: " + threadName + " create session");
            


        } catch (Exception ex) {
            ex.printStackTrace();
        } finally {
            if (context != null) {
                try {
                    context.close();
                } catch (NamingException ex) {
                    //ignore
                }
            }
            try {
                System.out.println("Thread: " + threadName + " Sleep for 60 s before closing connection");
                Thread.sleep(60000);
                System.out.println("Thread: " + threadName + " Sleep 60s - finished");
            } catch (InterruptedException ex) {
                Logger.getLogger(DoLookUp.class.getName()).log(Level.SEVERE, null, ex);
            }
            if (c != null)  {
                try {
                    System.out.println("Thread: " + threadName + " Try to close connection.");
                    c.close();
                    System.out.println("Thread: " + threadName + " Close connection - success");
                } catch (JMSException ex) {
                    ex.printStackTrace();
                }
            }
        }
    }

    /**
     * @param threadName the threadName to set
     */
    public void setThreadName(String threadName) {
        this.threadName = threadName;
    }
}
